#!/bin/bash -e

if [ "$3" == "" ] ; then
    echo "Usage : $0 <original-system.ts.txt> <mutants-dir> <result.csv> [<hkc-options>]";
    echo "Exemple : $0 svm/svm.ts.txt svm/mutants/order1-tbk/";
    return;
fi;

dir=$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )

ORIG=$1
MUTANTDIR=$2
RESULTS=$3
DEBUG=0
NUMFILES=($MUTANTDIR/*.txt)
NUMFILES=${#NUMFILES[@]}
CPT=0

#cleaning results file
if [ -e "$RESULTS" ] ; then
    rm $RESULTS
    touch $RESULTS
else
    touch $RESULTS
fi


function computEquivalence {
#echo "Processing  mutant: $f "

printf  "$CPT / $NUMFILES \033[0K\r"

#Computing equivalence
LINE=$($dir/hkc $4 $5 $6 $7 $8 $9 -equiv $ORIG $f)

#Retrieving equivalence result...
EQUIV=$(echo "$LINE" | awk ' /true,/ || /false,/ {if ($4 == "false,"){print "FALSE"} else if ($4 == "true,"){print "TRUE"}}')
#Retrieving equivalnce computation time...
T=$(echo "$LINE" | awk '/[0-9]+\.[0-9]+/{ print $5}')

#DEBUG...
if [ "$DEBUG" == 1 ] ; then
echo "$LINE"
echo "Equiv:  $EQUIV"
echo "Time: $T";
fi
CPT=$(($CPT + 1))
#Storing results
echo "$f;$EQUIV;$T" >> $RESULTS
}



ARRAY=($MUTANTDIR*.txt)
#Iterating over mutants...
for f in ${ARRAY[@]}
do

computEquivalence &
#echo "toto: $f" &
NPROC=$(($NPROC+1))
 if [ "$NPROC" -ge 4 ]; then
    wait
    NPROC=0
 fi

done
