#!/bin/bash -e

if [ "$1" == "" ] ; then
    echo "Usage : $0 <model>";
    echo "Exemple : $0 svm";
    exit 1;
fi;

dir=$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )

original=$dir/../models/$1/$1.ts
mutantsdir=$dir/../mutants/$1

alphabet=$original

# Original LTS
input=$original
statesmap=$input.timbuk.weak.statesmap.csv
actionsmap=$input.timbuk.weak.actionsmap.csv
output=$mutantsdir/$1.ts.timbuk.txt
java -jar $dir/toolbox-transformation-1.1.5-SNAPSHOT-jar-with-dependencies.jar -lts $input -timbuk all $alphabet $statesmap $actionsmap -out $output


for order in order1 order2 order5 order10 equiv; do
	echo "Processing $order for model $1"
	for input in $(ls $mutantsdir/$order/*.ts); do
		echo "Processing file $input"
			# weak mutation
			statesmap=$input.timbuk.weak.statesmap.csv
			actionsmap=$input.timbuk.weak.actionsmap.csv
			output=$input.timbuk.weak.txt
			java -jar $dir/toolbox-transformation-1.1.5-SNAPSHOT-jar-with-dependencies.jar -lts $input -timbuk all $alphabet $statesmap $actionsmap -out $output
			# strong mutation
			statesmap=$input.timbuk.strong.statesmap.csv
			actionsmap=$input.timbuk.strong.actionsmap.csv
			output=$input.timbuk.strong.txt
			java -jar $dir/toolbox-transformation-1.1.5-SNAPSHOT-jar-with-dependencies.jar -lts $input -timbuk initial $alphabet $statesmap $actionsmap -out $output
	done;
done;
